/**
 * The Blink program is a simple Mica2 application that simply turns the
 * LED on and off once per second. It configures the Timer0 device to
 * interrupt the processor twice per second and uses the interrupt routine
 * to toggle the red LED.
 *
 * @author Ben L. Titzer
 */
program Blink {
    components { Blink, Mica2, MCU }
    entrypoint main = Blink.entry;
    entrypoint timer0_comp = Timer0.compareHandler;
}

component Blink {
    constructor() {
        Mica2.setTimerCompare(Mica2.red.toggle); // set the function to call on overflow
    }

    method entry() {
	Mica2.startLEDs();
        Mica2.startTimer();           // start up the basic timer
        while ( true ) MCU.sleep();
    }
}
