/*
 * This program tests the operation of the radio driver.
 * @author Ben L. Titzer
 * @author Akop Palyan
 */
program TestRadio {
    components { TestRadio, Mica2 }
    entrypoint main = TestRadio.entry;
    entrypoint timer0_comp = Timer0.compareHandler;
    entrypoint usart0_rx = USART0.rec_handler;
    entrypoint usart0_udre = USART0.tran_handler;
    entrypoint spi_stc = SPI.interruptHandler;
}

component TestRadio {

    field buffer: char[] = new char[36];
    field pos: int = 0;

    constructor() {
        Mica2.setTimerCompare(sendPacket);
    }

    method entry() {
        local i: int;

        Mica2.startTimer();
        Mica2.startTerminal();
	Mica2.startSPI(false);
	CC1000.init(CC1000.PRESET0);
	CC1000.start();
	CC1000.rxMode();
	MCU.enable();
        while ( true ) {
	    pos = pos + SPI.read(buffer, pos, buffer.length - pos);
	    if (pos == buffer.length - 1) {
               for (i = 0; i < buffer.length; i++) {
	           Terminal.printHex(buffer[i]);
		   Terminal.nextLine();
	       }
	       pos = 0;
	    }
	}
    }

    method sendPacket() {
	// TODO: implement me.
    }
}
