/*
 * This program tests the operation of the USART serial driver.
 * @author Ryan Hall
 */
program TestUSART {

    components { TestUSART, MCU, USART0 }

    entrypoint main = TestUSART.entry;
    entrypoint usart0_rx = USART0.rec_handler;
    entrypoint usart0_udre = USART0.tran_handler;
}

component TestUSART {

    field t_buf : char[] = "ry";
    field r_buf : char[] = new char[10];
    field i : int = 0;

    method entry() {
	Mica2.startTerminal();
     
        while (true) {
            MCU.sleep();
            i = USART0.receive(r_buf, 0, 10);
            USART0.transmit(r_buf, 0, i);
        }
    }
}
